# Nuclear shape quantification

This folder has  the computational protocol for performing the image analysis on nuclear shapes relating to Fig. 2 and Figs. S2 and S3. 

## Requirements

- Python 2.7.
- [Matlab R2018b](https://uk.mathworks.com/downloads/web_downloads/download_release?release=R2018b). It is likely that versions 2017 and later will work too but we have not tested this.  Our scripts requires 
  - `Curve Fitting Toolbox`, 
  - `Image Processing Toolbox`,
  - `Statistics and Machine Learning Toolbox`. 
- The segmentation and tracking implementation (MARS/ALT) is using functions from [OpenAlea](http://openalea.gforge.inria.fr/dokuwiki/doku.php). This functionality could be replaced by using [timagetk](https://virtualplants.github.io/timagetk/) (more light-weight distribution of the segmentation and tracking) but that would require some  modification to the scripts (import statements).
- [ImageJ](https://fiji.sc/).
- [MorphoGraphX](https://www.mpipz.mpg.de/MorphoGraphX).

Note that most scripts include the path to data files, which needs to be adopted to the user setup. As mentioned in the main README file, the confocal data is available via the Cambridge Data repository.


## Protocol

What follows is a step by step protocol describing the use of different image processing and analysis tools, as well as MATLAB scripts, with the goal of segmenting and tracking individual cells and their respective nuclei in the L1 layer of the shoot apical meristem. 
Although this protocol was developed in the context of a morphometric study of nuclei at the meristem/organ primordia boundary, the steps herein should be - with minor changes - generally applicable to other problems in the same tissue or - with potentially more significant changes - other tissues.  

### Cell and nuclear segmentation using MARS

#### 1. ImageJ

Using ImageJ, open the original stack file. 
Go to `Image > Colour > Split Channels`. 
The result of this operation should be at least two new images (one per each channel in the original stack). 
Save each of these separately, noting which corresponds to membrane and nuclear channels. These will be the input files for the segmentation.

### Segmentation

A batch script, `segment_all.py`, is provided for looping through all the images and performing the segmentation. It contains a dictionary which specifies which parameter were used for each segmentation. It also contains paths and filenames. If your paths and filenames do not perfectly agree with ours, then you will need to edit these before you run the script. 

```bash
python2 src/segment_all.py
```

This script will perform the following operations:
1. Define parameters and paths to be used for the segmentations.
2. For each original confocal stack:
   1. Segment the membrane image (where the cell outlines visible).
   2. Segment the nucleus image using the same seeds as the membrane image. This means that the segmented images have the same labels for the same cells.
   3. Remove any obvious mis-segmentations where the nucleus is above some large volume threshold.
   4. Use the membrane segmentation to get a list of all cells on the epidermis (anything which borders the background). 


### Tracking using ALT

Tracking of individual cells is done using ALT. 
Tracking is done in a pair-wise manner for all consecutive time points. 
It is recommended to create a folder (e.g. ‘tracking’) for a given time course, where all the files and folders generated by ALT can be stored. 
For tracking between a given pair of consecutive time points, parameters should be changed in file `parameters.py`. 
Once the choice of parameters has been made, ALT is run by executing file `tracking.py`. 
In this description we assume membrane images are being used to do the tracking.

Parameters are as follows:

- `timePoints` - number of hours for the two time points (e.g 12 and 24 hours) for file names
- `ALTParameter` - to be used in `elastic_sigma` and `fluid_sigma` (for `BlockMatching`)
- `stretchingFactor0` - correction factor to account for z-stretching effects (image time t)
- `stretchingFactor1` - correction factor to account for z-stretching effects (image time t+1)
- `mainPath` - full path to the folder where all the ALT output files and folders will be saved
- `t0Path` - full path to the membrane channel image of time t
- `t1Path` - full path to the membrane channel image of time t+1
- `seg0Path` - full path to the membrane segmented image of time t
- `seg1Path` - full path to the membrane segmented image of time t+1

As it stands, the same `ALTParameter` is applied for both `BlockMatching` parameters - roughly, it determines the amount of non-linear transformations allowed when doing the registration between two time points. 
Typically, a value of 3 tends to provide good results - alternatively a value of 5 can sometimes be better. 
The vast majority of the times, either one or the other are used. 
Both `stretchingFactor0` and `stretchingFactor1` are only used when we have a correction factor for the stretching effect in the z direction caused by plant growth during image capture. 
This factor can be obtained by performing a quick scan of the tissue (large distance between slices) before performing the fine-grained image to be analysed. 
When no correction factor exists, parameter values should be left at 1. 
The `mainPath` parameter points to the folder where all files and folders will be stored. 
ALT generates a large number of files (within folders - one per pair of time points) and so it is recommended to keep everything in the same place.


Besides a number of `inr` image files for the different intermediate analysis steps, ALT generates a `pkl` file with all the label correspondences between the two consecutive time points (e.g. `matchingScores_24h_to_32h_ALT3.pkl`). 
In terms of the downstream analysis, this is the most important file since it will allow matching the two consecutive labels of a given cell between two time points. 
Also, it will show cell divisions when a parent label corresponds to two - or more, depending on the time interval - daughter labels. 
Of note as well, whenever label 1 appears in the list, this corresponds to the background. 
For ease of extraction, file `readMatchingScores.py` generates a txt file with all the label correspondences. 
The only parameter is `fName`, which corresponds to the full path of the `matchingScores...pkl` file.

### Surface segmentation in MorphoGraphX

Surface extraction, 2D cell segmentation and curvature quantification was done in MorphoGraphX (MGX) following a published protocol (Kiss et al. 2017).

##### Surface extraction.

Apply the level set method (LSM) with parameters :

- -> Process -> Stack -> LSM -> Initialization of the Level set: Linear threshold of the main stack: Up threshold  - 12, Down Threshold 10


- -> Process -> Stack -> LSM -> Level Set Evolve ( α = 0.75, β = 0.1, Threshold 0.001)
  - Activate the Main stack in parallel with the work to check the quality of the surface detection. 

- Use the Gaussian blur filter on the detected surface (Work) before proceeding to the Mesh creation.
  - -> Process -> Stack -> Filters -> Gaussian Blur Stack (x=y=z=0.3)

##### 2D cell segmentation

Create a mesh and project the membrane signal from the confocal stack on it.

- -> Process -> Mesh -> Creation -> Marching Cubes Surface (cube size - 3, Threshold 5000)
  - Smooth and subdivide the obtained mesh 3 times: 
    - -> Process -> Mesh -> Structure -> Smooth Mesh 
    - -> Process -> Mesh -> Structure -> Subdivide 

Project the membrane signal from the confocal stack on the mesh
- -> Process -> Mesh -> Signal -> Project Signal (Min Distance - 0.25µm, Max Distance - 6µm)

Segmentation: The most reliable for the boundary area is Watershed Segmentation after manual seeding. 

- Activate Surface Labels in Main, use the Add New Seed function to assign the labels for segmentation. When ready - apply
  - -> Process -> Mesh -> Segmentation -> Watershed Segmentation 
  - Simplify the Segmented mesh:
  - -> Process -> Mesh -> Fix Corners
  - -> Process -> Mesh -> Make Cells (Min Wall - 0.8)

Curvature quantification
- -> Process -> Mesh -> Cell Axis -> Curvature -> Compute Tissue Curvature (radius-10µm)
- -> Process -> Mesh -> Cell Axis -> Curvature -> Display Tissue Curvature (Heatmap - Gaussian)
- The obtained curvature values for individual call labels can be extracted  as a .txt:
  -  -> Process -> Mesh -> Heat Map -> Save Heat Map
     -  It can also be exported in .ply or .vtk formats
  - Mesh (in the main menu)-> Mesh1 -> Export

### Curvature extraction using MorphoGraphX

MorphoGraphX was used to quantify the curvature of the epidermis. In order for this to be useful downstream, we also need to map the MorphoGraphX and MARS segmentations so that we know which cell had which curvature in the MARS segmentation.

1. Open segmented stack (Stack1)

2. (Depending on where file was segmented, activate "Labels" -> Delete label tool -> click anywhere on green cube to remove background)

3. Using delete label tool, remove any unwanted cells (e.g. mis-segmentations)

4. Process -> Mesh -> Creation -> Marching Cubes 3D -> Cube Size = 1.0

5. Main -> deactivate Work Stack view (in view should now be the labeled 3D mesh of the segmented stack)

6. Mesh (in top menus) -> Mesh 2 -> Import -> Select the corresponding labeled mesh for curvature

7. Select Stack 2 -> Surface view on -> activate blending

8. Activate Mesh view -> View: Cells -> Draw mesh points and mesh lines active (in view should be the outlines of the cells in the curvature mesh above the segmented stack mesh with the label colors)

9. With Stack 2 selected in main, use the Grab label tool (leftmost bar) to click on each cell which should then inherit the colour of the mesh below

   9.1. It can help to deactivate "blending" in the surface view, in order to see which cells are still missing

10. Exporting correspondence: Process -> Mesh -> Lineage Tracking -> Save Parents

### Final analysis using Matlab

In these scripts, the information that we extracted using MARS, ALT and MorphoGraphX all gets processed, shapes are quantified, and the final results/figures are produced. 

- First open matlab and set the working directory to the folder `src/matlab`. 
- Open the file `generate_figures.m`.
- Update the path to the image directory in Section 1. 
Every timecourse of images have a number of paths and parameters which needs to be defined. 
These parameters are all stored in individual matlab scripts which are located in their respective images directory.
In order for the script to find them, we must add their path.

```matlab
addpath("PATH_TO_IMAGES/images/SUN1q_p18/")
```

- Edit parameters as needed in the `matlab_parameters.m` file located in the directory you just specified. Rerunning the scripts like we did will only require you to alter the `root_path` variable.

- Everything beyond the first section of `generate_figures.m` should be automated, simply run through the script section by section.

## Authors:
Jose Teles

[Niklas Korsbo](https://github.com/korsbo) 

Yassin Refahi

